import { ScopeNode } from "../schemaScope.js"
import type { TypeKind } from "../shared/implement.js"
import type { inferred } from "../shared/inference.js"
import { JsObjects } from "./jsObjects.js"
import { TsKeywords } from "./tsKeywords.js"
import { Validation } from "./validation.js"
export declare const builtins: ScopeNode<ArkResolutions>
export declare const nodes: ArkResolutions
export declare const schema: import("../schemaScope.js").SchemaParser<ArkResolutions>
export declare namespace schema {
	type cast<to, kind extends TypeKind = TypeKind> = {
		[inferred]?: to
		kind?: kind
	}
}
export type isSchemaCast<def> = typeof inferred | "kind" extends keyof def
	? true
	: false
export interface ArkResolutions
	extends TsKeywords.resolutions,
		JsObjects.resolutions,
		Validation.resolutions {}
//# sourceMappingURL=builtins.d.ts.map
