import { capitalize, throwParseError } from "@arktype/util"
import { BaseNode } from "../base.js"
export const throwInvalidOperandError = (...args) =>
	throwParseError(writeInvalidOperandMessage(...args))
export const writeInvalidOperandMessage = (kind, expected, actual) =>
	`${capitalize(kind)} operand must be ${
		expected.description
	} (was ${actual.exclude(expected)})`
export class BaseConstraint extends BaseNode {
	impliedSiblings
	intersect(r) {
		return this.intersectInternal(r)
	}
}
export class BasePrimitiveConstraint extends BaseConstraint {
	traverseApply = (data, ctx) => {
		if (!this.traverseAllows(data, ctx)) {
			ctx.error(this.errorContext)
		}
	}
	compile(js) {
		js.compilePrimitive(this)
	}
}
//# sourceMappingURL=constraint.js.map
