import { type Key } from "@arktype/util"
import type { TypeSchema } from "../../base.js"
import type { NodeCompiler } from "../../shared/compile.js"
import type { BaseMeta, declareNode } from "../../shared/declare.js"
import type { TypeKind, nodeImplementationOf } from "../../shared/implement.js"
import type { TraverseAllows, TraverseApply } from "../../shared/traversal.js"
import type { Type } from "../../types/type.js"
import { BaseConstraint } from "../constraint.js"
export interface IndexSchema extends BaseMeta {
	readonly key: TypeSchema
	readonly value: TypeSchema
}
export interface IndexInner extends BaseMeta {
	readonly key: Type<Key>
	readonly value: Type
}
export type IndexDeclaration = declareNode<{
	kind: "index"
	schema: IndexSchema
	normalizedSchema: IndexSchema
	inner: IndexInner
	prerequisite: object
	intersectionIsOpen: true
	childKind: TypeKind
}>
export declare class IndexNode extends BaseConstraint<IndexDeclaration> {
	static implementation: nodeImplementationOf<IndexDeclaration>
	readonly impliedBasis: Type<
		object,
		import("../../keywords/tsPrimitive.js").tsPrimitive.exports
	>
	readonly expression: string
	traverseAllows: TraverseAllows<object>
	traverseApply: TraverseApply<object>
	compile(js: NodeCompiler): void
}
export declare const writeInvalidPropertyKeyMessage: <indexDef extends string>(
	indexDef: indexDef
) => `Indexed key definition '${indexDef}' must be a string, number or symbol`
export type writeInvalidPropertyKeyMessage<indexDef extends string> =
	`Indexed key definition '${indexDef}' must be a string, number or symbol`
//# sourceMappingURL=index.d.ts.map
