import type { Node, TypeSchema } from "../../base.js"
import type { NodeCompiler } from "../../shared/compile.js"
import type { TraverseAllows, TraverseApply } from "../../shared/context.js"
import type { BaseMeta, declareNode } from "../../shared/declare.js"
import type { TypeKind, nodeImplementationOf } from "../../shared/implement.js"
import { BaseConstraint } from "../constraint.js"
export interface OptionalInner extends BaseMeta {
	readonly key: string | symbol
	readonly value: Node<TypeKind>
}
export interface OptionalSchema extends BaseMeta {
	readonly key: string | symbol
	readonly value: TypeSchema
}
export type OptionalDeclaration = declareNode<{
	kind: "optional"
	schema: OptionalSchema
	normalizedSchema: OptionalSchema
	inner: OptionalInner
	prerequisite: object
	intersectionIsOpen: true
	childKind: TypeKind
}>
export declare class OptionalNode extends BaseConstraint<
	OptionalDeclaration,
	typeof OptionalNode
> {
	static implementation: nodeImplementationOf<OptionalDeclaration>
	readonly impliedBasis: import("../../types/domain.js").DomainNode<object>
	readonly serializedKey: string
	readonly compiledKey: string
	readonly expression: string
	traverseAllows: TraverseAllows<object>
	traverseApply: TraverseApply<object>
	compile(js: NodeCompiler): void
}
//# sourceMappingURL=optional.d.ts.map
