import { type Key } from "@arktype/util"
import type { Node, TypeSchema } from "../../base.js"
import type { NodeCompiler } from "../../shared/compile.js"
import type { BaseMeta, declareNode } from "../../shared/declare.js"
import type { TypeKind, nodeImplementationOf } from "../../shared/implement.js"
import type { TraverseAllows, TraverseApply } from "../../shared/traversal.js"
import { BaseConstraint } from "../constraint.js"
export interface PropSchema extends BaseMeta {
	readonly key: Key
	readonly value: TypeSchema
	readonly optional?: boolean
}
export interface PropInner extends BaseMeta {
	readonly key: Key
	readonly value: Node<TypeKind>
	readonly optional?: true
}
export type PropDeclaration = declareNode<{
	kind: "prop"
	schema: PropSchema
	normalizedSchema: PropSchema
	inner: PropInner
	errorContext: {
		key: Key
	}
	prerequisite: object
	intersectionIsOpen: true
	childKind: TypeKind
}>
export declare class PropNode extends BaseConstraint<PropDeclaration> {
	static implementation: nodeImplementationOf<PropDeclaration>
	readonly required: boolean
	readonly impliedBasis: import("../../main.js").Type<
		object,
		import("../../keywords/tsPrimitive.js").tsPrimitive.exports
	>
	readonly serializedKey: string
	readonly compiledKey: string
	readonly expression: string
	readonly errorContext: Readonly<{
		code: "prop"
		description: string
		key: Key
	}>
	traverseAllows: TraverseAllows<object>
	traverseApply: TraverseApply<object>
	compile(js: NodeCompiler): void
}
//# sourceMappingURL=prop.d.ts.map
