import { DynamicBase, type Key } from "@arktype/util"
import type { Node } from "../../base.js"
import type { Scope } from "../../scope.js"
import type { NodeCompiler } from "../../shared/compile.js"
import type { PropKind } from "../../shared/implement.js"
import type { TraverseAllows, TraverseApply } from "../../shared/traversal.js"
import type { IntersectionNode } from "../../types/intersection.js"
import type { Type } from "../../types/type.js"
export type ExtraneousKeyBehavior = "ignore" | ExtraneousKeyRestriction
export type ExtraneousKeyRestriction = "throw" | "prune"
export type PropsGroupInput = Pick<
	IntersectionNode,
	PropKind | "onExtraneousKey"
>
export declare class PropsGroup extends DynamicBase<PropsGroupInput> {
	inner: PropsGroupInput
	$: Scope
	constructor(inner: PropsGroupInput, $: Scope)
	readonly exhaustive: boolean
	readonly all: readonly Node<"prop" | "index" | "sequence">[]
	readonly nameSet: {
		[x: string]: 1
		[x: symbol]: 1
	}
	readonly nameSetReference: `$ark.${string}`
	readonly description: string
	readonly expression: string
	readonly literalKeys: Key[]
	private keyofCache
	rawKeyOf(): Type
	traverseAllows: TraverseAllows<object>
	traverseApply: TraverseApply<object>
	compile(js: NodeCompiler): void
	protected compileEnumerable(js: NodeCompiler): void
	protected compileExhaustive(js: NodeCompiler): void
}
//# sourceMappingURL=props.d.ts.map
