import type { Node, TypeSchema } from "../../base.js"
import type { NodeCompiler } from "../../shared/compile.js"
import type { TraverseAllows, TraverseApply } from "../../shared/context.js"
import type { BaseMeta, declareNode } from "../../shared/declare.js"
import type { TypeKind, nodeImplementationOf } from "../../shared/implement.js"
import { BaseConstraint } from "../constraint.js"
export interface RequiredSchema extends BaseMeta {
	readonly key: string | symbol
	readonly value: TypeSchema
}
export interface RequiredInner extends BaseMeta {
	readonly key: string | symbol
	readonly value: Node<TypeKind>
}
export type RequiredDeclaration = declareNode<{
	kind: "required"
	schema: RequiredSchema
	normalizedSchema: RequiredSchema
	inner: RequiredInner
	errorContext: {
		code: "required"
		key: string | symbol
	}
	prerequisite: object
	intersectionIsOpen: true
	childKind: TypeKind
}>
export declare class RequiredNode extends BaseConstraint<
	RequiredDeclaration,
	typeof RequiredNode
> {
	static implementation: nodeImplementationOf<RequiredDeclaration>
	readonly impliedBasis: import("../../types/domain.js").DomainNode<object>
	readonly serializedKey: string
	readonly compiledKey: string
	readonly expression: string
	readonly errorContext: Readonly<{
		code: "required"
		description: string
		key: string | symbol
	}>
	traverseAllows: TraverseAllows<object>
	traverseApply: TraverseApply<object>
	compile(js: NodeCompiler): void
}
//# sourceMappingURL=required.d.ts.map
