import type { declareNode } from "../../shared/declare.js"
import type { nodeImplementationOf } from "../../shared/implement.js"
import type { TraverseAllows } from "../../shared/traversal.js"
import {
	BaseRange,
	type BaseNormalizedRangeSchema,
	type BaseRangeInner,
	type LimitSchemaValue
} from "./range.js"
export interface AfterInner extends BaseRangeInner {
	rule: Date
}
export interface NormalizedAfterSchema extends BaseNormalizedRangeSchema {
	rule: LimitSchemaValue
}
export type AfterSchema = NormalizedAfterSchema | LimitSchemaValue
export type AfterDeclaration = declareNode<{
	kind: "after"
	schema: AfterSchema
	normalizedSchema: NormalizedAfterSchema
	inner: AfterInner
	prerequisite: Date
	errorContext: AfterInner
}>
export declare class AfterNode extends BaseRange<AfterDeclaration> {
	static implementation: nodeImplementationOf<AfterDeclaration>
	readonly impliedBasis: import("../../main.js").Type<
		Date,
		import("../../keywords/jsObject.js").jsObject.exports
	>
	traverseAllows: TraverseAllows<Date>
}
//# sourceMappingURL=after.d.ts.map
