import type { declareNode } from "../../shared/declare.js"
import type { nodeImplementationOf } from "../../shared/implement.js"
import type { TraverseAllows } from "../../shared/traversal.js"
import {
	BaseRange,
	type BaseNormalizedRangeSchema,
	type BaseRangeInner,
	type LimitSchemaValue
} from "./range.js"
export interface BeforeInner extends BaseRangeInner {
	rule: Date
}
export interface NormalizedBeforeSchema extends BaseNormalizedRangeSchema {
	rule: LimitSchemaValue
}
export type BeforeSchema = NormalizedBeforeSchema | LimitSchemaValue
export type BeforeDeclaration = declareNode<{
	kind: "before"
	schema: BeforeSchema
	normalizedSchema: NormalizedBeforeSchema
	inner: BeforeInner
	prerequisite: Date
	errorContext: BeforeInner
}>
export declare class BeforeNode extends BaseRange<BeforeDeclaration> {
	static implementation: nodeImplementationOf<BeforeDeclaration>
	readonly impliedBasis: import("../../main.js").Type<
		Date,
		import("../../keywords/jsObject.js").jsObject.exports
	>
	traverseAllows: TraverseAllows<Date>
}
//# sourceMappingURL=before.d.ts.map
