import type { BaseMeta, declareNode } from "../../shared/declare.js"
import type { TraverseAllows } from "../../shared/traversal.js"
import type { Type } from "../../types/type.js"
import {
	BasePrimitiveConstraint,
	writeInvalidOperandMessage
} from "../constraint.js"
export interface DivisorInner extends BaseMeta {
	readonly rule: number
}
export type DivisorSchema = DivisorInner | number
export type DivisorDeclaration = declareNode<{
	kind: "divisor"
	schema: DivisorSchema
	normalizedSchema: DivisorInner
	inner: DivisorInner
	prerequisite: number
	errorContext: DivisorInner
}>
export declare class DivisorNode extends BasePrimitiveConstraint<DivisorDeclaration> {
	static implementation: import("../../shared/implement.js").nodeImplementationOf<{
		reducibleTo: "divisor"
		intersectionIsOpen: false
		childKind: never
		kind: "divisor"
		schema: DivisorSchema
		normalizedSchema: DivisorInner
		inner: DivisorInner
		prerequisite: number
		errorContext: DivisorInner &
			import("../../shared/declare.js").BaseErrorContext<"divisor">
	}>
	traverseAllows: TraverseAllows<number>
	readonly compiledCondition: string
	readonly compiledNegation: string
	readonly impliedBasis: Type<
		number,
		import("../../keywords/tsPrimitive.js").tsPrimitive.exports
	>
	readonly errorContext: {
		code: "divisor"
		readonly rule: number
		readonly description?: string
	}
	readonly expression: string
}
export declare const writeIndivisibleMessage: <node extends Type<any, any>>(
	t: node
) => writeIndivisibleMessage<node>
export type writeIndivisibleMessage<node extends Type> =
	writeInvalidOperandMessage<"divisor", node>
//# sourceMappingURL=divisor.d.ts.map
