import type { BaseMeta, declareNode } from "../../shared/declare.js"
import type { TraverseAllows } from "../../shared/traversal.js"
import { BasePrimitiveConstraint } from "../constraint.js"
import type { LengthBoundableData } from "./range.js"
export interface ExactLengthInner extends BaseMeta {
	readonly rule: number
}
export type NormalizedExactLengthSchema = ExactLengthInner
export type ExactLengthSchema = NormalizedExactLengthSchema | number
export type ExactLengthDeclaration = declareNode<{
	kind: "exactLength"
	schema: ExactLengthSchema
	normalizedSchema: NormalizedExactLengthSchema
	inner: ExactLengthInner
	prerequisite: LengthBoundableData
	errorContext: ExactLengthInner
}>
export declare class ExactLengthNode extends BasePrimitiveConstraint<ExactLengthDeclaration> {
	static implementation: import("../../shared/implement.js").nodeImplementationOf<{
		reducibleTo: "exactLength"
		intersectionIsOpen: false
		childKind: never
		kind: "exactLength"
		schema: ExactLengthSchema
		normalizedSchema: ExactLengthInner
		inner: ExactLengthInner
		prerequisite: LengthBoundableData
		errorContext: ExactLengthInner &
			import("../../shared/declare.js").BaseErrorContext<"exactLength">
	}>
	traverseAllows: TraverseAllows<LengthBoundableData>
	readonly compiledCondition: string
	readonly compiledNegation: string
	readonly impliedBasis: import("../../main.js").Type<
		string | unknown[],
		import("../../keywords/internal.js").internalPrimitive.exports
	>
	readonly errorContext: {
		code: "exactLength"
		readonly rule: number
		readonly description?: string
	}
	readonly expression: string
}
//# sourceMappingURL=exactLength.d.ts.map
