import type { declareNode } from "../../shared/declare.js"
import {
	BasePrimitiveConstraint,
	type PrimitiveConstraintInner
} from "../constraint.js"
import type { LengthBoundableData } from "./range.js"
export interface LengthInner extends PrimitiveConstraintInner<number> {}
export type length<n extends number> = {
	"==": n
}
export type NormalizedLengthSchema = LengthInner
export type LengthSchema = NormalizedLengthSchema | number
export type LengthDeclaration = declareNode<{
	kind: "length"
	schema: LengthSchema
	normalizedSchema: NormalizedLengthSchema
	inner: LengthInner
	prerequisite: LengthBoundableData
	errorContext: LengthInner
}>
export declare class LengthNode extends BasePrimitiveConstraint<
	LengthDeclaration,
	typeof LengthNode
> {
	static implementation: import("../../shared/implement.js").nodeImplementationOf<{
		intersectionIsOpen: false
		childKind: never
		reducibleTo: "length"
		kind: "length"
		schema: LengthSchema
		normalizedSchema: LengthInner
		inner: LengthInner
		prerequisite: LengthBoundableData
		errorContext: LengthInner &
			import("../../shared/declare.js").BaseErrorContext<"length">
	}>
	traverseAllows: (data: LengthBoundableData) => boolean
	readonly compiledCondition: string
	readonly compiledNegation: string
	readonly impliedBasis: import("../../types/union.js").UnionNode<LengthBoundableData>
	readonly errorContext: {
		code: "length"
		description: string
		readonly rule: number
	}
	readonly expression: string
}
//# sourceMappingURL=length.d.ts.map
