import type { declareNode } from "../../shared/declare.js"
import type { nodeImplementationOf } from "../../shared/implement.js"
import {
	BaseRange,
	type BaseNormalizedRangeSchema,
	type BaseRangeInner
} from "./range.js"
export interface MaxInner extends BaseRangeInner {
	rule: number
}
export interface NormalizedMaxSchema extends BaseNormalizedRangeSchema {
	rule: number
}
export type MaxSchema = NormalizedMaxSchema | number
export type MaxDeclaration = declareNode<{
	kind: "max"
	schema: MaxSchema
	normalizedSchema: NormalizedMaxSchema
	inner: MaxInner
	prerequisite: number
	errorContext: MaxInner
}>
export declare class MaxNode extends BaseRange<MaxDeclaration> {
	static implementation: nodeImplementationOf<MaxDeclaration>
	readonly impliedBasis: import("../../main.js").Type<
		number,
		import("../../keywords/tsPrimitive.js").tsPrimitive.exports
	>
	traverseAllows: (data: number) => boolean
}
//# sourceMappingURL=max.d.ts.map
