import type { declareNode } from "../../shared/declare.js"
import type { nodeImplementationOf } from "../../shared/implement.js"
import {
	BaseRange,
	type BaseNormalizedRangeSchema,
	type BaseRangeInner,
	type LengthBoundableData
} from "./range.js"
export interface MaxLengthInner extends BaseRangeInner {
	rule: number
}
export interface NormalizedMaxLengthSchema extends BaseNormalizedRangeSchema {
	rule: number
}
export type MaxLengthSchema = NormalizedMaxLengthSchema | number
export type MaxLengthDeclaration = declareNode<{
	kind: "maxLength"
	schema: MaxLengthSchema
	normalizedSchema: NormalizedMaxLengthSchema
	inner: MaxLengthInner
	prerequisite: LengthBoundableData
	errorContext: MaxLengthInner
}>
export declare class MaxLengthNode extends BaseRange<MaxLengthDeclaration> {
	static implementation: nodeImplementationOf<MaxLengthDeclaration>
	readonly impliedBasis: import("../../main.js").Type<
		string | unknown[],
		import("../../keywords/internal.js").internalPrimitive.exports
	>
	traverseAllows: (data: LengthBoundableData) => boolean
}
//# sourceMappingURL=maxLength.d.ts.map
