import type { declareNode } from "../../shared/declare.js"
import type { nodeImplementationOf } from "../../shared/implement.js"
import {
	BaseRange,
	type BaseNormalizedRangeSchema,
	type BaseRangeInner
} from "./range.js"
export interface MinInner extends BaseRangeInner {
	rule: number
}
export interface NormalizedMinSchema extends BaseNormalizedRangeSchema {
	rule: number
}
export type MinSchema = NormalizedMinSchema | number
export type MinDeclaration = declareNode<{
	kind: "min"
	schema: MinSchema
	normalizedSchema: NormalizedMinSchema
	inner: MinInner
	prerequisite: number
	errorContext: MinInner
}>
export declare class MinNode extends BaseRange<MinDeclaration> {
	static implementation: nodeImplementationOf<MinDeclaration>
	readonly impliedBasis: import("../../main.js").Type<
		number,
		import("../../keywords/tsPrimitive.js").tsPrimitive.exports
	>
	traverseAllows: (data: number) => boolean
}
//# sourceMappingURL=min.d.ts.map
