import { BaseRange, parseExclusiveKey } from "./range.js"
export class MinNode extends BaseRange {
	static implementation = this.implement({
		collapsibleKey: "rule",
		hasAssociatedError: true,
		keys: {
			rule: {},
			exclusive: parseExclusiveKey
		},
		normalize: (schema) =>
			typeof schema === "number" ? { rule: schema } : schema,
		intersections: {
			min: (l, r) => (l.isStricterThan(r) ? l : r)
		},
		defaults: {
			description(node) {
				return `${node.exclusive ? "more than" : "at least"} ${
					node.rule
				}`
			}
		}
	})
	impliedBasis = this.$.keywords.number
	traverseAllows = this.exclusive
		? (data) => data > this.rule
		: (data) => data >= this.rule
}
//# sourceMappingURL=min.js.map
