import type { declareNode } from "../../shared/declare.js"
import type { nodeImplementationOf } from "../../shared/implement.js"
import {
	BaseRange,
	type BaseNormalizedRangeSchema,
	type BaseRangeInner,
	type LengthBoundableData
} from "./range.js"
export interface MinLengthInner extends BaseRangeInner {
	rule: number
}
export interface NormalizedMinLengthSchema extends BaseNormalizedRangeSchema {
	rule: number
}
export type MinLengthSchema = NormalizedMinLengthSchema | number
export type MinLengthDeclaration = declareNode<{
	kind: "minLength"
	schema: MinLengthSchema
	normalizedSchema: NormalizedMinLengthSchema
	inner: MinLengthInner
	prerequisite: LengthBoundableData
	errorContext: MinLengthInner
}>
export declare class MinLengthNode extends BaseRange<MinLengthDeclaration> {
	static implementation: nodeImplementationOf<MinLengthDeclaration>
	traverseAllows: (data: LengthBoundableData) => boolean
	readonly impliedBasis: import("../../main.js").Type<
		string | unknown[],
		import("../../keywords/internal.js").internalPrimitive.exports
	>
}
//# sourceMappingURL=minLength.d.ts.map
