import type { BaseMeta, declareNode } from "../../shared/declare.js"
import { BasePrimitiveConstraint } from "../constraint.js"
export interface RegexInner extends BaseMeta {
	readonly rule: string
	readonly flags?: string
}
export type NormalizedRegexSchema = RegexInner
export type RegexSchema = NormalizedRegexSchema | string | RegExp
export type RegexDeclaration = declareNode<{
	kind: "regex"
	schema: RegexSchema
	normalizedSchema: NormalizedRegexSchema
	inner: RegexInner
	intersectionIsOpen: true
	prerequisite: string
	errorContext: RegexInner
}>
export declare class RegexNode extends BasePrimitiveConstraint<RegexDeclaration> {
	static implementation: import("../../shared/implement.js").nodeImplementationOf<{
		reducibleTo: "regex"
		childKind: never
		kind: "regex"
		schema: RegexSchema
		normalizedSchema: RegexInner
		inner: RegexInner
		intersectionIsOpen: true
		prerequisite: string
		errorContext: RegexInner &
			import("../../shared/declare.js").BaseErrorContext<"regex">
	}>
	readonly instance: RegExp
	readonly expression: string
	traverseAllows: (string: string) => boolean
	readonly compiledCondition: string
	readonly compiledNegation: string
	readonly impliedBasis: import("../../main.js").Type<
		string,
		import("../../keywords/tsPrimitive.js").tsPrimitive.exports
	>
	readonly errorContext: {
		code: "regex"
		readonly rule: string
		readonly flags?: string
		readonly description?: string
	}
}
//# sourceMappingURL=regex.d.ts.map
