import {
	wellFormedIntegerMatcher,
	wellFormedNumberMatcher
} from "@arktype/util"
import { root } from "./root.js"
import { parsedDate } from "./utils/date.js"
const number = root.schema({
	in: {
		domain: "string",
		regex: wellFormedNumberMatcher,
		description: "a well-formed numeric string"
	},
	morphs: (s) => parseFloat(s)
})
const integer = root.schema({
	in: {
		domain: "string",
		regex: wellFormedIntegerMatcher
	},
	morphs: (s) => {
		// if (!isWellFormedInteger(s)) {
		// 	return errors.mustBe("a well-formed integer string")
		// }
		// const parsed = parseInt(s)
		// return Number.isSafeInteger(parsed)
		// 	? parsed
		// 	: errors.mustBe(
		// 			"an integer in the range Number.MIN_SAFE_INTEGER to Number.MAX_SAFE_INTEGER"
		// 	  )
		return parseInt(s)
	}
})
const url = root.schema({
	in: {
		domain: "string",
		description: "a valid URL"
	},
	morphs: (s) => {
		return new URL(s)
		// try {
		// 	return new URL(s)
		// } catch {
		// 	return state.mustBe("a valid URL", s, state.basePath)
		// }
	}
})
const json = root.schema({
	in: {
		domain: "string",
		description: "a JSON-parsable string"
	},
	morphs: (s) => JSON.parse(s)
})
const date = parsedDate
export const parsing = {}
export const parsingKeywords = {}
// 	Scope.root.scope({
// 	url,
// 	number,
// 	integer,
// 	date,
// 	json
// })
//# sourceMappingURL=parsing.js.map
