import { PredicateNode } from "./constraints/predicate.js"
import { IndexNode } from "./constraints/props/index.js"
import { PropNode } from "./constraints/props/prop.js"
import { SequenceNode } from "./constraints/props/sequence.js"
import { DivisorNode } from "./constraints/refinements/divisor.js"
import { BoundNodes } from "./constraints/refinements/kinds.js"
import { RegexNode } from "./constraints/refinements/regex.js"
import { DomainNode } from "./types/domain.js"
import { IntersectionNode } from "./types/intersection.js"
import { MorphNode } from "./types/morph.js"
import { ProtoNode } from "./types/proto.js"
import { UnionNode } from "./types/union.js"
import { UnitNode } from "./types/unit.js"
export const nodesByKind = {
	...BoundNodes,
	domain: DomainNode,
	unit: UnitNode,
	proto: ProtoNode,
	union: UnionNode,
	morph: MorphNode,
	intersection: IntersectionNode,
	divisor: DivisorNode,
	regex: RegexNode,
	predicate: PredicateNode,
	prop: PropNode,
	index: IndexNode,
	sequence: SequenceNode
}
//# sourceMappingURL=kinds.js.map
