import { type evaluate } from "@arktype/util"
import { type Node, type UnknownNode } from "./base.js"
import { type Schema, type reducibleKindOf } from "./kinds.js"
import type { Scope } from "./scope.js"
import { type NodeKind } from "./shared/implement.js"
export type SchemaParseOptions = {
	alias?: string
	prereduced?: boolean
	/** Instead of creating the node, compute the innerId of the definition and
	 * point it to the specified resolution.
	 *
	 * Useful for defining reductions like number|string|bigint|symbol|object|true|false|null|undefined => unknown
	 **/
	reduceTo?: UnknownNode
	root?: boolean
	allowedKinds?: readonly NodeKind[]
}
export type SchemaParseContext = evaluate<
	SchemaParseOptions & {
		$: Scope
		raw: unknown
	}
>
export declare function parseAttachments<defKind extends NodeKind>(
	kind: defKind,
	schema: Schema<defKind>,
	ctx: SchemaParseContext
): Node<reducibleKindOf<defKind>>
//# sourceMappingURL=parse.d.ts.map
