import { CompiledFunction } from "@arktype/util"
import type { Node, UnknownNode } from "../base.js"
import type { Discriminant } from "../types/discriminate.js"
import type { PrimitiveKind } from "./implement.js"
import type { TraversalKind } from "./traversal.js"
export type InvokeOptions = {
	arg?: string
	kind?: TraversalKind
}
export declare class NodeCompiler extends CompiledFunction<["data", "ctx"]> {
	traversalKind: TraversalKind
	path: string[]
	discriminants: Discriminant[]
	constructor(traversalKind: TraversalKind)
	invoke(node: UnknownNode, opts?: InvokeOptions): string
	requiresContextFor(node: UnknownNode): boolean
	checkReferenceKey(keyExpression: string, node: UnknownNode): this
	check(node: UnknownNode, opts?: InvokeOptions): this
	compilePrimitive(node: Node<PrimitiveKind>): this
	writeMethod(name: string): string
}
//# sourceMappingURL=compile.d.ts.map
