import { ArkErrors, type ArkErrorInput } from "./errors.js"
import type { ParsedArkConfig } from "../schemaScope.js"
export type TraversalPath = (string | symbol)[]
export declare const pathToPropString: (path: TraversalPath) => string
export declare class TraversalContext {
	root: unknown
	config: ParsedArkConfig
	path: TraversalPath
	errorsStack: ArkErrors[]
	entriesToPrune: [data: Record<string, unknown>, key: string][]
	seen: {
		[name in string]?: object[]
	}
	constructor(root: unknown, config: ParsedArkConfig)
	get currentErrors(): ArkErrors
	get error(): (
		input: ArkErrorInput
	) => import("./errors.js").ArkTypeError<
		| "max"
		| "min"
		| "maxLength"
		| "minLength"
		| "before"
		| "after"
		| "length"
		| "union"
		| "unit"
		| "intersection"
		| "proto"
		| "domain"
		| "regex"
		| "divisor"
		| "required"
		| "predicate"
	>
	get data(): unknown
	invalid(input: ArkErrorInput): false
	pushUnion(): void
	popUnion(branchCount: number, data: unknown, path: string[]): void
}
export type TraversalMethodsByKind<input = unknown> = {
	Allows: TraverseAllows<input>
	Apply: TraverseApply<input>
}
export type TraversalKind = keyof TraversalMethodsByKind
export type TraverseAllows<data = unknown> = (
	data: data,
	ctx: TraversalContext
) => boolean
export type TraverseApply<data = unknown> = (
	data: data,
	ctx: TraversalContext
) => void
//# sourceMappingURL=context.d.ts.map
