import { literalPropAccess } from "@arktype/util"
import { ArkErrors } from "./errors.js"
export const pathToPropString = (path) => {
	const propAccessChain = path.reduce(
		(s, segment) => s + literalPropAccess(segment),
		""
	)
	return propAccessChain[0] === "."
		? propAccessChain.slice(1)
		: propAccessChain
}
export class TraversalContext {
	root
	config
	path = []
	errorsStack
	// TODO: add morphs here
	entriesToPrune = []
	// Qualified
	seen = {}
	constructor(root, config) {
		this.root = root
		this.config = config
		this.errorsStack = [new ArkErrors(this)]
	}
	get currentErrors() {
		return this.errorsStack.at(-1)
	}
	get error() {
		return this.currentErrors.add.bind(this.currentErrors)
	}
	get data() {
		let result = this.root
		for (const segment of this.path) {
			result = result?.[segment]
		}
		return result
	}
	invalid(input) {
		this.error(input)
		return false
	}
	pushUnion() {
		this.errorsStack.push(new ArkErrors(this))
	}
	popUnion(branchCount, data, path) {
		const branchProblems = this.errorsStack.pop()
		if (branchProblems.count === branchCount) {
			// this.addError("union", { data: this.data, errors: branchProblems })
		}
	}
}
//# sourceMappingURL=context.js.map
