import {
	type Domain,
	type SerializedPrimitive,
	type evaluate
} from "@arktype/util"
import type { UnionChildNode } from "./union.js"
export type CaseKey<kind extends DiscriminantKind = DiscriminantKind> =
	DiscriminantKind extends kind ? string : DiscriminantKinds[kind] | "default"
export type Discriminant<kind extends DiscriminantKind = DiscriminantKind> =
	Readonly<{
		readonly path: string[]
		readonly kind: kind
		readonly cases: DiscriminatedCases<kind>
		readonly isPureRootLiteral: boolean
	}>
export type DiscriminatedCases<
	kind extends DiscriminantKind = DiscriminantKind
> = Readonly<{
	[caseKey in CaseKey<kind>]: Discriminant | UnionChildNode[]
}>
export type DiscriminantKinds = {
	domain: Domain
	value: SerializedPrimitive
}
export type DiscriminantKind = evaluate<keyof DiscriminantKinds>
export declare const discriminate: (
	branches: readonly UnionChildNode[]
) => Discriminant | null
export declare const writeUndiscriminableMorphUnionMessage: <
	path extends string
>(
	path: path
) => `${string} union including one or more morphs must be discriminable`
//# sourceMappingURL=discriminate.d.ts.map
