import { type NonEnumerableDomain } from "@arktype/util"
import type { BaseMeta, declareNode } from "../shared/declare.js"
import type { TraverseAllows } from "../shared/traversal.js"
import { BaseBasis } from "./basis.js"
export interface DomainInner<
	domain extends NonEnumerableDomain = NonEnumerableDomain
> extends BaseMeta {
	readonly domain: domain
}
export type DomainSchema<
	domain extends NonEnumerableDomain = NonEnumerableDomain
> = domain | NormalizedDomainSchema<domain>
export type NormalizedDomainSchema<
	domain extends NonEnumerableDomain = NonEnumerableDomain
> = DomainInner<domain>
export type DomainDeclaration = declareNode<{
	kind: "domain"
	schema: DomainSchema
	normalizedSchema: NormalizedDomainSchema
	inner: DomainInner
	errorContext: DomainInner
}>
export declare class DomainNode<t = any, $ = any> extends BaseBasis<
	t,
	DomainDeclaration,
	$
> {
	static implementation: import("../shared/implement.js").nodeImplementationOf<{
		reducibleTo: "domain"
		intersectionIsOpen: false
		prerequisite: unknown
		childKind: never
		kind: "domain"
		schema: DomainSchema<
			"string" | "number" | "bigint" | "symbol" | "object"
		>
		normalizedSchema: NormalizedDomainSchema<
			"string" | "number" | "bigint" | "symbol" | "object"
		>
		inner: DomainInner<"string" | "number" | "bigint" | "symbol" | "object">
		errorContext: DomainInner<
			"string" | "number" | "bigint" | "symbol" | "object"
		> &
			import("../shared/declare.js").BaseErrorContext<"domain">
	}>
	traverseAllows: TraverseAllows
	readonly compiledCondition: string
	readonly compiledNegation: string
	readonly errorContext: {
		code: "domain"
		readonly domain: "string" | "number" | "bigint" | "symbol" | "object"
		readonly description?: string
	}
	readonly expression: "string" | "number" | "bigint" | "symbol" | "object"
	readonly literalKeys: import("@arktype/util").Key[]
}
//# sourceMappingURL=domain.d.ts.map
