import { type Constructor } from "@arktype/util"
import type { BaseMeta, declareNode } from "../shared/declare.js"
import type { TraverseAllows } from "../shared/traversal.js"
import { BaseBasis } from "./basis.js"
export interface ProtoInner<proto extends Constructor = Constructor>
	extends BaseMeta {
	readonly proto: proto
}
export type NormalizedProtoSchema<proto extends Constructor = Constructor> =
	ProtoInner<proto>
export type ProtoSchema<proto extends Constructor = Constructor> =
	| proto
	| NormalizedProtoSchema<proto>
export type ProtoDeclaration = declareNode<{
	kind: "proto"
	schema: ProtoSchema
	normalizedSchema: NormalizedProtoSchema
	inner: ProtoInner
	errorContext: ProtoInner
}>
export declare class ProtoNode<t = any, $ = any> extends BaseBasis<
	t,
	ProtoDeclaration,
	$
> {
	static implementation: import("../shared/implement.js").nodeImplementationOf<{
		reducibleTo: "proto"
		intersectionIsOpen: false
		prerequisite: unknown
		childKind: never
		kind: "proto"
		schema: ProtoSchema<Constructor>
		normalizedSchema: NormalizedProtoSchema<Constructor>
		inner: ProtoInner<Constructor>
		errorContext: ProtoInner<Constructor> &
			import("../shared/declare.js").BaseErrorContext<"proto">
	}>
	traverseAllows: TraverseAllows
	readonly expression: string
	readonly serializedConstructor: string
	readonly domain = "object"
	readonly compiledCondition: string
	readonly compiledNegation: string
	readonly errorContext: {
		code: "proto"
		readonly proto: Constructor
		readonly description?: string
	}
	readonly literalKeys: (string | symbol)[]
}
//# sourceMappingURL=proto.d.ts.map
