import type { BaseMeta, declareNode } from "../shared/declare.js"
import { BaseBasis } from "./basis.js"
export type UnitSchema<value = unknown> = UnitInner<value>
export interface UnitInner<value = unknown> extends BaseMeta {
	readonly unit: value
}
export type UnitDeclaration = declareNode<{
	kind: "unit"
	schema: UnitSchema
	normalizedSchema: UnitSchema
	inner: UnitInner
	errorContext: UnitInner
}>
export declare class UnitNode<t = any, $ = any> extends BaseBasis<
	t,
	UnitDeclaration,
	$
> {
	static implementation: import("../shared/implement.js").nodeImplementationOf<{
		reducibleTo: "unit"
		intersectionIsOpen: false
		prerequisite: unknown
		childKind: never
		kind: "unit"
		schema: UnitSchema<unknown>
		normalizedSchema: UnitSchema<unknown>
		inner: UnitInner<unknown>
		errorContext: UnitInner<unknown> &
			import("../shared/declare.js").BaseErrorContext<"unit">
	}>
	traverseAllows: (data: unknown) => boolean
	readonly compiledValue: string | number | boolean | null
	readonly serializedValue: string | number | boolean | null
	readonly compiledCondition: string
	readonly compiledNegation: string
	readonly errorContext: {
		code: "unit"
		readonly unit: unknown
		readonly description?: string
	}
	readonly expression: string
	readonly domain: import("@arktype/util").Domain
	readonly literalKeys: never[]
}
//# sourceMappingURL=unit.d.ts.map
