import type { UnknownNode } from "./base.js"
import type { Module, Scope } from "./scope.js"
import type { ArkTypeError } from "./shared/errors.js"
import type { Generic } from "./type.js"
export declare const arkKind: unique symbol
export type ArkKinds = {
	node: UnknownNode
	scope: Scope
	generic: Generic
	module: Module
	error: ArkTypeError
}
export type ArkKind = keyof ArkKinds
export declare const addArkKind: <kind extends keyof ArkKinds>(
	value: Omit<ArkKinds[kind], typeof arkKind> & {
		[arkKind]?: kind
	},
	kind: kind
) => ArkKinds[kind]
export type addArkKind<
	kind extends ArkKind,
	t extends Omit<ArkKinds[kind], arkKind>
> = t & {
	[arkKind]: kind
}
export type arkKind = typeof arkKind
export declare const hasArkKind: <kind extends keyof ArkKinds>(
	value: unknown,
	kind: kind
) => value is ArkKinds[kind]
//# sourceMappingURL=util.d.ts.map
